"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContextEvaluator = void 0;
const ramda_1 = __importDefault(require("ramda"));
class ContextEvaluator {
    /**
     * @param {import('./CubeEvaluator').CubeEvaluator} cubeEvaluator
     */
    constructor(cubeEvaluator) {
        this.cubeEvaluator = cubeEvaluator;
        this.contextDefinitions = {};
    }
    // eslint-disable-next-line no-unused-vars
    compile(contexts, _errorReporter) {
        if (contexts.length === 0) {
            return;
        }
        // TODO: handle duplications, context names must be uniq
        this.contextDefinitions = ramda_1.default.compose(ramda_1.default.fromPairs, ramda_1.default.map(v => [v.name, this.compileContext(v)]))(contexts);
    }
    compileContext(context) {
        return {
            name: context.name,
            contextMembers: this.cubeEvaluator.evaluateReferences(null, context.contextMembers)
        };
    }
    get contextList() {
        return ramda_1.default.keys(this.contextDefinitions);
    }
}
exports.ContextEvaluator = ContextEvaluator;
//# sourceMappingURL=ContextEvaluator.js.map