"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LightweightSymbolResolver = void 0;
const CubeSymbols_1 = require("../CubeSymbols");
class LightweightSymbolResolver {
    symbols;
    constructor(symbols = {}) {
        this.symbols = symbols;
    }
    setSymbols(symbols) {
        this.symbols = symbols;
    }
    isCurrentCube(name) {
        return CubeSymbols_1.CURRENT_CUBE_CONSTANTS.indexOf(name) >= 0;
    }
    resolveSymbol(cubeName, name) {
        if (name === 'USER_CONTEXT') {
            throw new Error('Support for USER_CONTEXT was removed, please migrate to SECURITY_CONTEXT.');
        }
        if (CubeSymbols_1.CONTEXT_SYMBOLS[name]) {
            return true;
        }
        const cube = this.symbols[this.isCurrentCube(name) ? cubeName : name];
        return cube || (this.symbols[cubeName] && this.symbols[cubeName][name]);
    }
}
exports.LightweightSymbolResolver = LightweightSymbolResolver;
//# sourceMappingURL=LightweightSymbolResolver.js.map